clang 10.0.0git

Public Member Functions | List of all members
clang::consumed::ConsumedBlockInfo Class Reference

`#include "clang/Analysis/Analyses/Consumed.h"`

## Public Member Functions
| ConsumedBlockInfo ()=default
| ConsumedBlockInfo (unsigned int NumBlocks, PostOrderCFGView *SortedGraph)
bool | allBackEdgesVisited (const CFGBlock *CurrBlock, const CFGBlock *TargetBlock)
void | addInfo (const CFGBlock *Block, ConsumedStateMap *StateMap, std::unique_ptr< ConsumedStateMap > &OwnedStateMap)
void | addInfo (const CFGBlock *Block, std::unique_ptr< ConsumedStateMap > StateMap)
ConsumedStateMap * | borrowInfo (const CFGBlock *Block)
void | discardInfo (const CFGBlock *Block)
std::unique_ptr< ConsumedStateMap > | getInfo (const CFGBlock *Block)
bool | isBackEdge (const CFGBlock *From, const CFGBlock *To)
bool | isBackEdgeTarget (const CFGBlock *Block)

## Detailed Description

Definition at line 207 of file Consumed.h.

## Constructor & Destructor Documentation

## ◆ ConsumedBlockInfo() [1/2]

clang::consumed::ConsumedBlockInfo::ConsumedBlockInfo | ( |  | ) |
| default

## ◆ ConsumedBlockInfo() [2/2]

clang::consumed::ConsumedBlockInfo::ConsumedBlockInfo | ( | unsigned int | NumBlocks,
|  | PostOrderCFGView * | SortedGraph
| ) |  |
| inline

Definition at line 214 of file Consumed.h.

References getInfo().

## Member Function Documentation

## ◆ addInfo() [1/2]

void ConsumedBlockInfo::addInfo | ( | const CFGBlock * | Block,
|  | ConsumedStateMap * | StateMap,
|  | std::unique_ptr< ConsumedStateMap > & | OwnedStateMap
| ) |  |

Definition at line 1017 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ addInfo() [2/2]

void ConsumedBlockInfo::addInfo | ( | const CFGBlock * | Block,
|  | std::unique_ptr< ConsumedStateMap > | StateMap
| ) |  |

Definition at line 1032 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ allBackEdgesVisited()

bool ConsumedBlockInfo::allBackEdgesVisited | ( | const CFGBlock * | CurrBlock,
|  | const CFGBlock * | TargetBlock
| ) |  |

Definition at line 1003 of file Consumed.cpp.

References clang::CFGBlock::getBlockID(), clang::CFGBlock::pred_begin(), and clang::CFGBlock::pred_end().

## ◆ borrowInfo()

ConsumedStateMap * ConsumedBlockInfo::borrowInfo | ( | const CFGBlock * | Block | ) |

Definition at line 1045 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ discardInfo()

void ConsumedBlockInfo::discardInfo | ( | const CFGBlock * | Block | ) |

Definition at line 1052 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ getInfo()

std::unique_ptr< ConsumedStateMap > ConsumedBlockInfo::getInfo | ( | const CFGBlock * | Block | ) |

Definition at line 1057 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ isBackEdge()

bool ConsumedBlockInfo::isBackEdge | ( | const CFGBlock * | From,
|  | const CFGBlock * | To
| ) |  |

Definition at line 1065 of file Consumed.cpp.

References clang::CFGBlock::getBlockID().

## ◆ isBackEdgeTarget()

bool ConsumedBlockInfo::isBackEdgeTarget | ( | const CFGBlock * | Block | ) |

Definition at line 1072 of file Consumed.cpp.

References clang::CFGBlock::getBlockID(), clang::CFGBlock::pred_begin(), clang::CFGBlock::pred_end(), and clang::CFGBlock::pred_size().

The documentation for this class was generated from the following files:

- include/clang/Analysis/Analyses/Consumed.h
- lib/Analysis/Consumed.cpp